#ifndef _SSD1306SPI
#define _SSD1306SPI

//#include "stm32f1xx_hal.h"
#include "stm32f4xx_hal.h"

#include "../def.h"
#include "../ansi.h"
//#include "graph.h"


//-----------------------------------------------------------------------*/
#define SSD1306_128_64
//   #define SSD1306_128_32
//   #define SSD1306_96_16


#define	SSD1306_I2C			// zdefinowanie wybiera I2C
//#define	SSD1306_SPI			// zdefinowanie wybiera SPI, mozna wybrac SPI i I2C razem


#define	GFX_LOGO_AVT


/*=========================================================================*/
//	#define	GFX_LINE					// Wlaczenie funkcji rysujacej linie (duze zuzycie pamieci FLASH i RAM)
										// todo: uzyc kod�w bez operacji zzmiennoprzecinkowych


#if defined SSD1306_128_64 && defined SSD1306_128_32
  #error "Only one SSD1306 display can be specified at once in SSD1306.h"
#endif
#if !defined SSD1306_128_64 && !defined SSD1306_128_32 && !defined SSD1306_96_16
  #error "At least one SSD1306 display must be specified in SSD1306.h"
#endif

#if defined SSD1306_128_64
  #define SSD1306_LCDWIDTH              128
  #define SSD1306_LCDHEIGHT             64
#endif
#if defined SSD1306_128_32
  #define SSD1306_LCDWIDTH              128
  #define SSD1306_LCDHEIGHT             32
#endif
#if defined SSD1306_96_16
  #define SSD1306_LCDWIDTH              96
  #define SSD1306_LCDHEIGHT             16
#endif

#define SSD1306_SETCONTRAST 			0x81
#define SSD1306_DISPLAYALLON_RESUME 	0xA4
#define SSD1306_DISPLAYALLON 			0xA5
#define SSD1306_NORMALDISPLAY 			0xA6
#define SSD1306_INVERTDISPLAY 			0xA7
#define SSD1306_DISPLAYOFF 				0xAE
#define SSD1306_DISPLAYON 				0xAF

#define SSD1306_SETDISPLAYOFFSET 		0xD3
#define SSD1306_SETCOMPINS 				0xDA

#define SSD1306_SETVCOMDETECT 			0xDB

#define SSD1306_SETDISPLAYCLOCKDIV 		0xD5
#define SSD1306_SETPRECHARGE 			0xD9

#define SSD1306_SETMULTIPLEX 			0xA8

#define SSD1306_SETLOWCOLUMN 			0x00
#define SSD1306_SETHIGHCOLUMN 			0x10

#define SSD1306_SETSTARTLINE 			0x40

#define SSD1306_MEMORYMODE 				0x20
#define SSD1306_COLUMNADDR 				0x21
#define SSD1306_PAGEADDR   				0x22

#define SSD1306_COMSCANINC 				0xC0
#define SSD1306_COMSCANDEC 				0xC8

#define SSD1306_SEGREMAP 				0xA0

#define SSD1306_CHARGEPUMP 				0x8D

#define SSD1306_EXTERNALVCC 			0x1
#define SSD1306_SWITCHCAPVCC 			0x2

// Scrolling #defines
#define SSD1306_ACTIVATE_SCROLL							0x2F
#define SSD1306_DEACTIVATE_SCROLL						0x2E
#define SSD1306_SET_VERTICAL_SCROLL_AREA				0xA3
#define SSD1306_RIGHT_HORIZONTAL_SCROLL					0x26
#define SSD1306_LEFT_HORIZONTAL_SCROLL					0x27
#define SSD1306_VERTICAL_AND_RIGHT_HORIZONTAL_SCROLL	0x29
#define SSD1306_VERTICAL_AND_LEFT_HORIZONTAL_SCROLL		0x2A




extern void ssd1306_command(uint8_t c);
extern void ssd1306_init( uint8_t display );
extern void ssd1306_clearDisplay(void);
extern void ssd1306_invertDisplay(uint8_t i);
extern uint8_t ssd1306_display(uint8_t dma);


extern void ssd1306_startscrollright(uint8_t start, uint8_t stop, uint8_t speed);
extern void ssd1306_startscrollleft(uint8_t start, uint8_t stop, uint8_t speed);

extern void ssd1306_startscrolldiagright(uint8_t start, uint8_t stop, uint8_t speed);
extern void ssd1306_startscrolldiagleft(uint8_t start, uint8_t stop,  uint8_t speed);
extern void ssd1306_stopscroll(void);

extern void ssd1306_dim(byte dim);

extern int16_t ssd1306_DrawFont(int16_t x, int16_t y, char znak, uint8_t color );
extern int16_t ssd1306_PrintString(int16_t x, int16_t y, char *text, uint8_t color);
extern void ssd1306_drawPixel(int16_t x, int16_t y, uint16_t color);
extern uint8_t ssd1306_getPixel(int16_t x, int16_t y);
extern void ssd1306_DrawBitmap1616(int16_t x, int16_t y, uint8_t *buf, uint8_t color );

extern void ssd1306_drawFastVLine(int16_t x, int16_t y, int16_t h, uint8_t color);
extern void ssd1306_drawFastHLine(int16_t x, int16_t y, int16_t w, uint8_t color);
extern void ssd1306_drawFastHLineInternal(int16_t x, int16_t y, int16_t w, uint8_t color);
extern void ssd1306_drawFastVLineInternal(int16_t x, int16_t __y, int16_t __h, uint8_t color);

extern int16_t ssd1306_Box(int16_t x, int16_t y, uint16_t wys, uint16_t sz, uint8_t color, char wypelnienie );
extern int16_t ssd1306_LineV( int16_t x, int16_t y, uint16_t len, uint8_t color );
extern int16_t ssd1306_LineH( int16_t x, int16_t y, uint16_t len, uint8_t color );

extern void ssd1306_SetFont( uint16_t f );
extern uint8_t ssd1306_GetFontSizeX(void);
extern uint8_t ssd1306_GetFontSizeY(void);


#endif
